class BaseReturnType
{
   @Override
   public String toString()
   {
      return "base class return type";
   }
}

class DerivedReturnType extends BaseReturnType
{
   @Override
   public String toString()
   {
      return "derived class return type";
   }
}

class BaseClass
{
   BaseReturnType createReturnType()
   {
      return new BaseReturnType();
   }
}

class DerivedClass extends BaseClass
{
   @Override
   BaseReturnType createReturnType()
   {
      return new DerivedReturnType();
   }
}

public class CRTDemo
{
   public static void main(String[] args)
   {
      BaseReturnType brt = new BaseClass().createReturnType();
      System.out.println(brt);
      DerivedReturnType drt = 
         (DerivedReturnType) new DerivedClass().createReturnType();
      System.out.println(drt);
   }
}